<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@version	CVS: $Id: main.act.php,v 1.1.1.1 2006/02/20 21:52:24 xiam Exp $
	*	@link		http://www.gekkoware.org
	*/

	define ("IN-GEKKO", true);

	require_once "../../conf.php";

	LoadLib (
		"file.lib.php",
		"image.lib.php",
		"categories"
	);

	db_init();

	require_once GEKKO_ROOT."lib/auth.inc.php";

	varImport("action", "id", "return");

	if (is_admin()) {
		// administrative tasks
		switch ($action) {
			case "delete":
				execWithEach($id, "Categories::deleteItem");
			break;
			case "disable":
				Categories::setItemStatus($id, 0);
			break;
			case "enable":
				Categories::setItemStatus($id, 1);
			break;
			case "create":

				varImport (
					"icon", "category", "description", "status", "auth_access"
				);

				varRequire (
					"category"
				);

				// custom icon?
				if ($_POST["remote_file"] || $_FILES["local_file"]["size"]) {
					// getting file from path (if it was uploaded) or by url
					$thumb = file_get("local_file", "remote_file");
					if ($thumb) {
						$thumb = mkthumbnail($thumb["abs_loc"], "50x50");
						$icon = $thumb["url"];
					}
				}

				// checking for duplicated category name
				$db->query ("SELECT id
				FROM ".db_table("category")."
				WHERE category = '{$category}'",
				__FILE__, __LINE__);

				// there is another category with that name!
				if ($db->num_rows())
					abort(_l("E_DUPLICATED_CATEGORY"));

				// insertinnew category into database
				$db->query ("
				INSERT INTO ".db_table("category")."
					(
						id,
						icon,
						category,
						description,
						status,
						auth_access
					)
						VALUES
					(
						'".$db->free_id("category")."',
						'{$icon}',
						'{$category}',
						'{$description}',
						'{$status}',
						'{$auth_access}'
					)
				", __FILE__, __LINE__);

				slog("categories: created '$category'", "actions", 1);
			break;
			case "edit":

				varImport (
					"icon", "category", "description", "status", "auth_access"
				);

				varRequire (
					"id", "category"
				);

				// another icon specified?
				if ($_POST["remote_file"] || $_FILES["local_file"]["size"]) {
					$thumb = file_get("local_file", "remote_file");

					if ($thumb) {
						// creating a new icon
						$thumb = mkthumbnail($thumb["abs_loc"], "50x50");
						$icon = $thumb["url"];

						// deleting old icon
						$orig = db_get_field("category", $id, "icon");
						if (file_exists($opath = GEKKO_ROOT.$orig)) {
							@unlink($opath);
						}
					}
				}

				// updating category information
				$db->query ("
					UPDATE ".db_table("category")." SET
						icon = '{$icon}',
						category = '{$category}',
						description = '{$description}',
						status = '{$status}',
						auth_access = '{$auth_access}'
					WHERE id = '{$id}'
				", __FILE__, __LINE__);

			break;
			default:
				abort(_l("E_UNKNOWN_ACTION"));
			break;
		}
	}
	redirect($return ? $return : $_SERVER["HTTP_REFERER"]);

	db_exit();
?>