<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@version	CVS: $Id: main.inc.php,v 1.1.1.1 2006/02/20 21:52:24 xiam Exp $
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	LoadLib("categories");

	Extract (
		URLGetArgs ("null/category=string?id=int")
	);

	setDefault("category",	"");

	if ($id) {

		$tpl = new ContentBlock();
		$tpl->insert("BLOCK_CONTENT", "categories/index.tpl");

		$db->query("SELECT
		id, icon, category, description, auth_access
		FROM ".db_table("category")."
		WHERE status = '1' AND id='{$id}'",
		__FILE__, __LINE__);

		$row = $db->fetch_row();

		if ($db->num_rows() && gauth($row["auth_access"])) {

			$row["icon"] = mkIcon($row["icon"], 48);

			$modules = modCore::getModules();

			// including a little script from every module from where it can list
			// contents that are related to this category.
			foreach ($modules as $module) {

				// script is called mod_categories.inc.php
				$file = GEKKO_ROOT."modules/{$module}/mod_categories.inc.php";

				// if file above exists, including it
				if (file_exists($file)) {

					$data = Array(
						'entries' 	=> Array(), // module contents that are related to this category
						'module' 	=> '' // module info
					);

					include ($file);

					if (($entries = count($data["entries"])) > 0) {
						$tpl->reset("MODULE.ENTRY");
						foreach ($data["entries"] as $entry) {
							$tpl->set_arr($entry, "MODULE.ENTRY");
							$tpl->saveBuff("MODULE.ENTRY");
						}
						$tpl->set_arr($data["module"], "MODULE");
						$tpl->saveBuff("MODULE");
					}

				}

			}

			$tpl->set_arr($row);
			$tpl->set_arr(
				Array (
					"BLOCK_TITLE"	=> _l("L_CATEGORY"),
					"BLOCK_ICON"	=> mkIcon("categories.png"),
					"ENTRIES"		=> isset($entries) ? $entries : 0
				)
			);
			$mcBuff = $tpl->make();
		} else {
			$mcBuff = accessDenied();
		}
	} else {

		$tpl = new ContentBlock();
		$tpl->insert("BLOCK_CONTENT", "categories/category.tpl");

		$db->query ("
		SELECT
			id, icon, category, description, auth_access
		FROM ".db_table("category")." WHERE status = '1'
		ORDER BY category ASC
		", __FILE__, __LINE__);

		while ($row = $db->fetch_row()) {
			if (gauth($row["auth_access"])) {
				// access granted!
				$tpl->set_arr ($row, "CATEGORY");
				$tpl->set_arr (
					Array (
						"icon"		=> mkIcon($row["icon"], 48),
						"category"	=> mkLink("index.php/module=categories/category=".title_encode($row["category"])."?id={$row['id']}", $row["category"]),
					)
					, "CATEGORY"
				);
				$tpl->saveBuff("CATEGORY");
			}
		}

		$tpl->set_arr (
			Array (
				"BLOCK_TITLE"		=> _l("L_CATEGORIES"),
				"BLOCK_ICON"		=> mkIcon("categories.png")
			)
		);

		$mcBuff = $tpl->make();
	}

?>