<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@version	CVS: $Id: main.lib.php,v 1.1.1.1 2006/02/20 21:52:24 xiam Exp $
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	Class Categories {

		/**
		* deleteItem(category id)
		* @return: true / false
		*/
		function deleteItem($id) {
			slog("categories: deleted '$id'", "actions", 1);
			return $GLOBALS["db"]->query ("DELETE FROM ".db_table("category")." WHERE id='{$id}'", __FILE__, __LINE__, true);
		}

		/**
		* setItemStatus(category id, [boolean] status)
		* @return: true / false
		*/
		function setItemStatus($id, $status) {
			return $GLOBALS["db"]->query ("UPDATE ".db_table("category")." SET status = '{$status}' WHERE id='{$id}'", __FILE__, __LINE__, true);
		}

		/**
		* fetchList(at least one);
		* @return: array id->categories
		* When $one_at_least is set to 'true' and if no category was found
		* then redirects browser to category administration section.
		*
		*/
		function fetchList($one_at_least = false) {
			$return = array();
			$q = $GLOBALS["db"]->query("SELECT id, category FROM ".db_table("category")." ORDER BY category ASC", __FILE__, __LINE__, true);
			while ($row = $GLOBALS["db"]->fetch_row($q)) {
				saneHTML($row);
				$return[$row["id"]] = $row["category"];
			}
			if ($one_at_least && !count($return)) {
				header("Location: "._l("C_SITE.URL")."index.php/module=admin/base=categories?message=".urlencode(_l("L_CATEGORY_REQUIRED"))."&return=".urlencode($_SERVER["REQUEST_URI"]));
				abort();
			}
			return $return;
		}

		/**
		* mkIcon(category id);
		* @return: a html formatted category icon
		*
		*/
		function mkIcon($id) {
			$q = $GLOBALS["db"]->query("SELECT category, icon FROM ".db_table("category")."
			WHERE id='$id'", __FILE__, __LINE__, true);
			$row = $GLOBALS["db"]->fetch_row($q);
			return mkIcon($row["icon"], 48);
		}

		/**
		* getCategory(category id, [boolean] $only_name);
		* @return: a html formatted link or only category name
		*
		*/
		function getCategory($id, $only_name = false) {

			$q = $GLOBALS["db"]->query("SELECT category
			FROM ".db_table("category")." WHERE id = '$id'", __FILE__, __LINE__, true);
			$row = $GLOBALS["db"]->fetch_row($q);

			saneHTML($row);

			if ($only_name)
				return $row["category"];

			return $GLOBALS["db"]->num_rows($q) ? mkLink("index.php/module=categories/category=".title_encode($row["category"])."?id=$id", $row["category"]) : false;
		}

		/**
		* getID(category_name);
		* @returns: category ID
		*
		*/
		function getID($name) {
			$db =& $GLOBALS["db"];
			$ids = Array();

			$names = explode(",", $name);
			foreach ($names as $name) {
				$q = $db->query("SELECT id
				FROM ".db_table("category")." WHERE category = '{$name}'", __FILE__, __LINE__, true);

				if ($db->num_rows($q)) {
					$row = $db->fetch_row($q);
					$ids[] = $row["id"];
				}
			}

			if ($ids)
				return implode(",", $ids);
			else
				return false;
		}

		/**
		* match();
		* @return: sql
		*/
		function match($ids, $field = "category") {

			$ids = explode(",", $ids);

			foreach ($ids as $id)
				$sql[] = "$field='$id'";

			$sql = implode(" OR ", $sql);

			return $sql;
		}

		/**
		* auth();
		* @return: true if the current user has enough privileges to access items listed in this category
		*
		*/
		function auth($id) {

			$q = $GLOBALS["db"]->query("SELECT auth_access
			FROM ".db_table("category")." WHERE id = '{$id}'",
			__FILE__, __LINE__, true);
			$row = $GLOBALS["db"]->fetch_row($q);

			return gauth($row["auth_access"]);
		}

		function createLock($field_name = "category", $auth = null) {
			return cache_func("Categories::fetchAllowed", true, $field_name, $auth);
		}

		/**
		* fetchAllowed([boolean] create sql lock, sql lock field, auth string)
		* @return: array id->id
		* Lists allowed categories by id (if isset(...)) or returns a SQL formatted condition
		* for to use in a query.
		*
		*/
		function fetchAllowed($sql_lock = false, $sql_lock_field = "category", $auth = null) {

			$return = Array();

			$q = $GLOBALS["db"]->query("SELECT id, auth_access
			FROM ".db_table("category")."
			WHERE status = '1'", __FILE__, __LINE__, true);

			while ($row = $GLOBALS["db"]->fetch_row($q)) {
				if (gauth($row["auth_access"], $auth))
					$return[$row["id"]] = $row["id"];
			}

			if ($sql_lock)
				$return = "$sql_lock_field = '".implode($return, "' OR $sql_lock_field = '")."'";

			return $return;
		}
	}
?>